# Author: Tharathorn Bunrattanasathian
# Student ID: 6110546011

require 'net/http'
require 'uri'
require 'nokogiri'

def retrieve_data_asset_value(symbol)
  url = "https://www.set.or.th/set/companyhighlight.do?symbol=#{symbol}"
  source = Net::HTTP.get(URI.parse(url))
  doc = Nokogiri::HTML(source)
  last_asset_value = doc.xpath('//*[@id="maincontent"]').xpath('//div[@class="table-responsive"]//table//tbody').first.xpath("//tr").drop(2).first.children.reverse.drop(3).first.text
  last_asset_value == "  " ? "No last assets value found!" : last_asset_value
end

def output_each(xnode)
  symbol = xnode.children[1].text
  puts "#{symbol} : #{xnode.children[3].text} : #{retrieve_data_asset_value(symbol)}"
end

class NoobScraper
  def start
    stock_list_url = 'https://www.set.or.th/set/commonslookup.do'
    stock_list_page_source = Net::HTTP.get(URI.parse(stock_list_url))

    doc = Nokogiri::HTML(stock_list_page_source)
    @all_stocks = doc.xpath('//*[@id="maincontent"]//div[@class="row"]//div//div[@class="table-responsive"]//table//tr')
    @all_stocks.drop(1).each_with_index { |stock_node| output_each(stock_node) }
  end
end


